package cn.estsh.i3plus.ext.mes.pcn.apiservice.schedulejob;


import cn.estsh.i3plus.ext.mes.pcn.api.base.IMesEquipmentLogService;
import cn.estsh.impp.framework.boot.init.ApplicationProperties;
import cn.hutool.json.JSONObject;
import cn.hutool.json.JSONUtil;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.quartz.DisallowConcurrentExecution;
import org.quartz.JobExecutionContext;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

/**
 * @author wangjie
 * @version 1.0
 * @date 2021/2/2 16:44
 **/
@Slf4j
@DisallowConcurrentExecution
@Component
@ApiOperation("保存工艺参数job")
public class MesSaveVariableJob extends BaseMesScheduleJob {

    @Autowired
    private IMesEquipmentLogService mesEquipmentLogService;

    public MesSaveVariableJob() {
        super(MesSaveVariableJob.class, "保存工艺参数job");
    }

    @Override
    public void executeMesJob(JobExecutionContext context, ApplicationProperties applicationProperties) {

        log.info("保存工艺参数job -- START ");

        String jobParam = this.getJobParam();
        JSONObject jsonObject= JSONUtil.parseObj(jobParam);
        String organizeCode = jsonObject.getStr("organizeCode");

        if (null == organizeCode){
            log.error("请添加需要报工的工厂代码!");
            return;
        }

        long startTime = System.currentTimeMillis();

        mesEquipmentLogService.saveEquipmentLogDetails(organizeCode);

        long endTime = System.currentTimeMillis();

        log.info("保存工艺参数job --- END --- 耗时: {} ms", endTime - startTime);

    }

}
