package cn.estsh.i3plus.ext.mes.pcn.apiservice.serviceimpl.step;

import cn.estsh.i3plus.ext.mes.pcn.api.busi.IMesProductionDispatchContextStepService;
import cn.estsh.i3plus.ext.mes.pcn.api.busi.IMesProductionProcessContextStepService;
import cn.estsh.i3plus.ext.mes.pcn.pojo.context.MesProductionProcessContext;
import cn.estsh.i3plus.ext.mes.pcn.pojo.context.MesProductionPsOutContext;
import cn.estsh.i3plus.mes.pcn.serviceimpl.fsm.BaseStepService;
import cn.estsh.i3plus.pojo.mes.bean.MesProduceSn;
import cn.estsh.i3plus.pojo.mes.model.StationRequestBean;
import cn.estsh.i3plus.pojo.mes.model.StationResultBean;
import cn.estsh.i3plus.pojo.mes.model.StepResult;
import cn.estsh.i3plus.pojo.mes.repository.MesProduceSnRepository;
import cn.estsh.i3plus.pojo.mes.util.MesExtEnumUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;

import java.util.ArrayList;
import java.util.List;

/**
 * @Description : 保存零件条码信息工步
 * @Author : zxw
 **/
@Slf4j
@Service
public class MesProductSnSaveStepService extends BaseStepService {

    @Autowired
    private IMesProductionProcessContextStepService productionProcessContextStepService;

    @Autowired
    private MesProduceSnRepository mesProduceSnRepository;

    public static final String ORDER_NO_JIS_SORT = "ORDER_NO_JIS_SORT";

    @Autowired
    private IMesProductionDispatchContextStepService mesProductionDispatchContextStepService;

    @Override
    public StepResult execute(StationRequestBean reqBean) {

        StationResultBean resultBean = new StationResultBean();

        StepResult stepResult = StepResult.getSuccessComplete();

        List<MesProductionPsOutContext> mesProduceSnContexts = mesProductionDispatchContextStepService.getProductionPsOutContext(reqBean);
        List<MesProduceSn> mesProduceSns = new ArrayList<>();
        if (CollectionUtils.isEmpty(mesProduceSnContexts)) {
            foundExThrow(reqBean, "条码信息不能为空");
        }
        mesProduceSnContexts.forEach(mesProduceSnContext -> {
            MesProduceSn mesProduceSn = new MesProduceSn();
            //todo 要根据不同的加工结果，返回不同的结果 要分排序和非排序， 排序只保存工单对应的装配件、非排序要保存主条码和装配件记录。
            mesProduceSn.setSnStatus(MesExtEnumUtil.PRODUCE_SN_STATUS.OFFLINE.getValue());
            mesProduceSns.add(mesProduceSn);
        });
        mesProduceSnRepository.saveAll(mesProduceSns);

        return execSuccessCompleteAndSendMsgReturn(reqBean, resultBean.writeDbLog(), stepResult, "保存零件条码信息工步");
    }
}
