package cn.estsh.i3plus.ext.mes.pcn.apiservice.serviceimpl.step;

import akka.actor.ActorRef;
import akka.actor.ActorSystem;
import cn.estsh.i3plus.ext.mes.pcn.api.busi.IMesProductionDispatchContextStepService;
import cn.estsh.i3plus.ext.mes.pcn.api.busi.IMesProductionProcessContextStepService;
import cn.estsh.i3plus.ext.mes.pcn.pojo.context.MesCellEquipContext;
import cn.estsh.i3plus.ext.mes.pcn.pojo.context.MesProductionProcessContext;
import cn.estsh.i3plus.ext.mes.pcn.pojo.model.ActorMessage;
import cn.estsh.i3plus.mes.pcn.config.SpringExtProvider;
import cn.estsh.i3plus.mes.pcn.serviceimpl.fsm.BaseStepService;
import cn.estsh.i3plus.pojo.base.codemaker.SnowflakeIdMaker;
import cn.estsh.i3plus.pojo.mes.bean.MesProduceSn;
import cn.estsh.i3plus.pojo.mes.model.StationRequestBean;
import cn.estsh.i3plus.pojo.mes.model.StationResultBean;
import cn.estsh.i3plus.pojo.mes.model.StepResult;
import cn.estsh.i3plus.pojo.mes.util.MesExtEnumUtil;
import com.alibaba.fastjson.JSONObject;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;

import java.util.List;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

/**
 * @Description : 加工异常处理工步
 * @Author : zxw
 **/
@Slf4j
@Service
public class MesSaveProcessResultStepService extends BaseStepService {
    @Autowired
    private SnowflakeIdMaker snowflakeIdMaker;

    @Autowired
    private ActorSystem actorSystem;

    @Autowired
    private IMesProductionProcessContextStepService productionProcessContextStepService;

    @Autowired
    private MesVariableWhenFinishedReadStepService mesVariableWhenFinishedReadStepService;

    @Autowired
    private MesMouldRecordGenerateStepService mesMouldRecordGenerateStepService;

    @Autowired
    private MesProductSnSaveStepService MesProductSnSaveStepService;

    @Autowired
    private MesProductionReocrdGenerateStepService mesProductionReocrdGenerateStepService;

    @Autowired
    private IMesProductionDispatchContextStepService mesProductionDispatchContextStepService;

    @Autowired
    private MesProductResultErrorHandleStepService mesProductResultErrorHandleStepService;

    @Autowired
    private MesReportGenerateStepService mesReportGenerateStepService;

    public static final String ORDER_NO_JIS_SORT = "ORDER_NO_JIS_SORT";

    private static final Map<String, ActorRef> refMap = new ConcurrentHashMap<>(200);

    @Override
    public StepResult execute(StationRequestBean reqBean) {
        StationResultBean resultBean = new StationResultBean();

        StepResult stepResult = StepResult.getSuccessComplete();
        /**
         * 生成开模记录
         */
        mesMouldRecordGenerateStepService.execute(reqBean);
        /**
         * 保存零件条码信息工步
         */
        MesProductSnSaveStepService.execute(reqBean);
        /**
         * 生成加工记录工步
         */
        mesProductionReocrdGenerateStepService.execute(reqBean);
        /**
         * 加工异常处理工步
         */
        mesProductResultErrorHandleStepService.execute(reqBean);
        /**
         * 报工
         */
        // mesReportGenerateStepService.execute(reqBean);


        return execSuccessCompleteAndSendMsgReturn(reqBean, resultBean.writeDbLog(), stepResult, "保存加工结果成功");
  }
}
