package cn.estsh.i3plus.ext.mes.pcn.pojo.context;

import io.swagger.annotations.ApiParam;
import lombok.Data;

import java.io.Serializable;
import java.util.List;

/**
 * 生产过程上下文对象-设备LOG采集处理对象
 */
@Data
public class MesEquipLogDispatchContext implements Serializable {

    private static final long serialVersionUID = 917933189935264321L;

    @ApiParam("组织代码")
    private String organizeCode;

    @ApiParam("是否采集到数据")
    private Boolean isCollectValue = false;

    @ApiParam("是否常变值")
    private Boolean needNewValue = false;

    @ApiParam("数据变量接口逻辑信息集合")
    private List<MesEquipVariableCfgCollectContext> equipVariableCfgCollectContextList;

    public MesEquipLogDispatchContext() {}

    public MesEquipLogDispatchContext(String organizeCode) {
        this.organizeCode = organizeCode;
    }

    public MesEquipLogDispatchContext isCollectValue() {
        this.isCollectValue = true;
        return this;
    }

    public MesEquipLogDispatchContext needNewValue() {
        this.needNewValue = true;
        return this;
    }

    public MesEquipLogDispatchContext equipVariableCfgCollectContextList(List<MesEquipVariableCfgCollectContext> equipVariableCfgCollectContextList) {
        this.equipVariableCfgCollectContextList = equipVariableCfgCollectContextList;
        return this;
    }
}
